/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
//https://stackoverflow.com/questions/43935229/hashmap-with-8-million-entries-becomes-slow
//http://www2.imm.dtu.dk/pubdb/views/edoc_download.php/6364/pdf/imm6364.pdf
 */
package FunctionLayer;

import DataLayer.DataMapper;
import FunctionLayer.StanfordParser.SentimentAnalyzerTest;
import com.google.common.base.Stopwatch;
import com.google.common.collect.ArrayListMultimap;
import com.google.common.collect.MapMaker;
import com.google.common.collect.Multimap;
import edu.stanford.nlp.ling.HasWord;
import edu.stanford.nlp.ling.Label;
import edu.stanford.nlp.ling.TaggedWord;
import edu.stanford.nlp.ling.Word;
import edu.stanford.nlp.parser.lexparser.LexicalizedParser;
import edu.stanford.nlp.parser.shiftreduce.ShiftReduceParser;
import edu.stanford.nlp.process.DocumentPreprocessor;
import edu.stanford.nlp.tagger.maxent.MaxentTagger;
import edu.stanford.nlp.trees.Tree;
import edu.stanford.nlp.trees.TreebankLanguagePack;
import java.io.IOException;
import java.io.StringReader;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.concurrent.ConcurrentMap;
import java.util.concurrent.TimeUnit;
import java.util.function.Predicate;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author install1
 */
public class MYSQLDatahandler {

    public static final long EXPIRE_TIME_IN_SECONDS = TimeUnit.SECONDS.convert(10, TimeUnit.MINUTES);
    public static final long EXPIRE_TIME_IN_SECONDS1 = TimeUnit.SECONDS.convert(10, TimeUnit.HOURS);
    public static MYSQLDatahandler instance = new MYSQLDatahandler();
    public static int SemeticsUpdateCount;
    public static int threadCounter = 0;
    private volatile boolean RefreshMatrixFromDB;
    private final ConcurrentMap<Integer, String> StringCache;
    private List<SimilarityMatrix> SimilaritySMXList = new ArrayList();
    private List<String> multiprocessCalculations = new ArrayList();
    private final Stopwatch stopwatch;
    private final Stopwatch stopwatch1;

    public MYSQLDatahandler() {
        this.stopwatch = Stopwatch.createUnstarted();
        this.stopwatch1 = Stopwatch.createStarted();
        this.StringCache = new MapMaker().concurrencyLevel(2).makeMap();
    }

    private Map<Integer, String> getCache() throws SQLException, IOException, CustomError {
        List<String> strlist;
        strlist = DataMapper.getAllStrings();
        LinkedHashMap<Integer, String> LHM = new LinkedHashMap();
        int i = 0;
        for (String str : strlist) {
            LHM.put(i, str);
            i++;
        }
        return LHM;
    }

    public void initiateMYSQL() throws SQLException, IOException {
        try {
            DataMapper.createTables();
            StringCache.putAll(getCache());
            SimilaritySMXList = DataMapper.getAllSementicMatrixes();
        } catch (CustomError ex) {
            Logger.getLogger(MYSQLDatahandler.class
                    .getName()).log(Level.SEVERE, null, ex);
        }
    }

    public synchronized void checkIfUpdateMatrixes() {
        RefreshMatrixFromDB = false;
        int calculationBoundaries = 10;
        int updateBadgesInteger = 500;
        if (stopwatch1.elapsed(TimeUnit.SECONDS) >= EXPIRE_TIME_IN_SECONDS1) {
            RefreshMatrixFromDB = true;
            if (threadCounter == 0) {
                try {
                    SimilaritySMXList = DataMapper.getAllSementicMatrixes();
                    stopwatch1.reset();
                } catch (CustomError ex) {
                    Logger.getLogger(MYSQLDatahandler.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
        if (StringCache.values().size() > 10) {
            if (!RefreshMatrixFromDB && multiprocessCalculations.size() <= (calculationBoundaries * calculationBoundaries)) {
                threadCounter++;
                List<String> strList = new ArrayList(StringCache.values());
                SemeticsUpdateCount = new Random().nextInt(strList.size() - 6);
                int beginindex = SemeticsUpdateCount;
                SemeticsUpdateCount += calculationBoundaries / 2;
                int temp = SemeticsUpdateCount;
                List<String> strIndexNavigator = new ArrayList();
                strList.subList(beginindex, temp).forEach((str) -> {
                    strIndexNavigator.add(str);
                    multiprocessCalculations.add(str);
                });
                new Thread(() -> {
                    List<String> strIndexNavigatorL = new ArrayList(strIndexNavigator);
                    List<String> strIndexAll = new ArrayList(strList);
                    List<String> randomIndexesToUpdate = new ArrayList();
                    int indexes = updateBadgesInteger;
                    if (indexes >= strIndexAll.size()) {
                        indexes = strIndexAll.size() - 1;
                    }
                    int beginindexes = new Random().nextInt((strIndexAll.size()) - indexes);
                    strIndexAll.subList(beginindexes, beginindexes + indexes).forEach((str) -> {
                        randomIndexesToUpdate.add(str);
                    });
                    List<SimilarityMatrix> matrixUpdateList = new ArrayList();
                    strIndexNavigatorL.forEach((str) -> {
                        randomIndexesToUpdate.stream().filter((str1) -> (!str.equals(str1))).forEachOrdered((str1) -> {
                            boolean present = false;
                            if (multiprocessCalculations.contains(str1)) {
                                present = true;
                            } else {
                                for (SimilarityMatrix SMX : SimilaritySMXList) {
                                    if (SMX.getPrimaryString().equals(str) && SMX.getSecondaryString().equals(str1)) {
                                        present = true;
                                        break;
                                    }
                                    if (SMX.getPrimaryString().equals(str1) && SMX.getSecondaryString().equals(str)) {
                                        present = true;
                                        break;
                                    }
                                }
                            }
                            if (!present) {
                                SimilarityMatrix SMX = new SimilarityMatrix(str, str1);
                                double score = SentimentAnalyzerTest.sentimentanalyzing(str, str1);
                                SMX.setDistance(score);
                                matrixUpdateList.add(SMX);
                                SimilaritySMXList.add(SMX);
                            }
                        });
                    });
                    new Thread(() -> {
                        try {
                            if (!matrixUpdateList.isEmpty()) {
                                DataMapper.insertSementicMatrixes(matrixUpdateList);
                                System.out.println("finished datamapper semetic insert");
                            }
                            threadCounter--;
                        } catch (CustomError ex) {
                            Logger.getLogger(MYSQLDatahandler.class
                                    .getName()).log(Level.SEVERE, null, ex);
                        }
                    }).start();
                }).
                        start();
                try {
                    wait(800);
                } catch (InterruptedException ex) {
                    Logger.getLogger(MYSQLDatahandler.class.getName()).log(Level.SEVERE, null, ex);
                }
            } else {
                if (threadCounter == 0) {
                    List<String> strList = new ArrayList(StringCache.values());
                    List<SimilarityMatrix> matrixUpdateList = new ArrayList();
                    List<String> randomStrList = new ArrayList();
                    int indexes = updateBadgesInteger;
                    if (indexes >= strList.size()) {
                        indexes = strList.size() - 1;
                    }
                    int beginindexes = new Random().nextInt((strList.size()) - indexes);
                    strList.subList(beginindexes, beginindexes + indexes).forEach((str) -> {
                        randomStrList.add(str);
                    });
                    multiprocessCalculations.forEach((str) -> {
                        randomStrList.forEach((str1) -> {
                            boolean present = false;
                            for (SimilarityMatrix SMX : SimilaritySMXList) {
                                if (SMX.getPrimaryString().equals(str) && SMX.getSecondaryString().equals(str1)) {
                                    present = true;
                                    break;
                                }
                                if (SMX.getPrimaryString().equals(str1) && SMX.getSecondaryString().equals(str)) {
                                    present = true;
                                    break;
                                }
                            }
                            if (!present) {
                                SimilarityMatrix SMX = new SimilarityMatrix(str, str1);
                                double score = SentimentAnalyzerTest.sentimentanalyzing(str, str1);
                                SMX.setDistance(score);
                                matrixUpdateList.add(SMX);
                                SimilaritySMXList.add(SMX);
                            }
                        });
                    });
                    try {
                        if (!matrixUpdateList.isEmpty()) {
                            DataMapper.insertSementicMatrixes(matrixUpdateList);
                            System.out.println("finished datamapper semetic insert");
                        }
                    } catch (CustomError ex) {
                        Logger.getLogger(MYSQLDatahandler.class
                                .getName()).log(Level.SEVERE, null, ex);
                    }
                    multiprocessCalculations = new ArrayList();
                }
            }
        }
    }

    public synchronized void checkIfUpdateStrings() throws CustomError {
        if (stopwatch.elapsed(TimeUnit.SECONDS) >= EXPIRE_TIME_IN_SECONDS || !stopwatch.isRunning()) {
            new Thread(() -> {
                List<String> str = MessageResponseHandler.getStr();
                str = cutContent(str);
                str = filterContent(str);
                str = removeSlacks(str);
                List<String> strUpdate = new ArrayList();
                strUpdate.addAll(str);
                try {
                    DataMapper.InsertMYSQLStrings(strUpdate);
                } catch (CustomError ex) {
                    Logger.getLogger(MYSQLDatahandler.class
                            .getName()).log(Level.SEVERE, null, ex);
                }
                MessageResponseHandler.setStr(new ArrayList());
                int j = StringCache.size() + 1;
                for (String str1 : strUpdate) {
                    StringCache.put(j, str1);
                    j++;
                }
            }).start();
            if (!stopwatch.isRunning()) {
                stopwatch.start();
            } else {
                stopwatch.reset();
            }
        }
    }

    public String getResponseMsg(String str) throws CustomError {
        double Score = -10000;
        SimilarityMatrix SMXreturn = null;
        List<String> strLocal = new ArrayList(StringCache.values());
        for (String str1 : strLocal) {
            if (str.equals(str1)) {
                Iterator<SimilarityMatrix> SMXITR = SimilaritySMXList.iterator();
                while (SMXITR.hasNext()) {
                    SimilarityMatrix SMX = SMXITR.next();
                    if (SMX.getPrimaryString().equals(str) || SMX.getSecondaryString().equals(str)) {
                        double smxDistance = SMX.getDistance();
                        if (smxDistance > Score) {
                            Score = smxDistance;
                            SMXreturn = SMX;
                        }
                    }
                }
                break;
            }
        }
        if (SMXreturn != null) {
            if (SMXreturn.getPrimaryString().equals(str)) {
                return SMXreturn.getSecondaryString();
            } else {
                return SMXreturn.getPrimaryString();
            }
        }
        String[] toArray = strLocal.toArray(new String[strLocal.size()]);
        String mostSimilarSTR = mostSimilar(str, toArray);
        Iterator<SimilarityMatrix> SMXITR = SimilaritySMXList.iterator();
        while (SMXITR.hasNext()) {
            System.out.println("mostSimilarSTR; " + mostSimilarSTR + "\n");
            mostSimilarSTR = mostSimilarSTR.trim();
            SimilarityMatrix SMX = SMXITR.next();
            if (SMX.getPrimaryString().trim().equals(mostSimilarSTR) || SMX.getSecondaryString().trim().equals(mostSimilarSTR)) {
                double smxDistance = SMX.getDistance();
                if (smxDistance > Score) {
                    Score = smxDistance;
                    SMXreturn = SMX;
                }
            }
        }
        if (SMXreturn != null) {
            if (SMXreturn.getPrimaryString().equals(str)) {
                return SMXreturn.getSecondaryString();
            } else {
                return SMXreturn.getPrimaryString();
            }
        }
        SMXITR = SimilaritySMXList.iterator();
        while (SMXITR.hasNext()) {
            SimilarityMatrix SMX = SMXITR.next();
            if (SMX.getPrimaryString().contains(mostSimilarSTR) || SMX.getSecondaryString().contains(mostSimilarSTR)) {
                double smxDistance = SMX.getDistance();
                if (smxDistance > Score) {
                    Score = smxDistance;
                    SMXreturn = SMX;
                }
            }
        }
        if (SMXreturn != null) {
            if (SMXreturn.getPrimaryString().equals(str)) {
                return SMXreturn.getSecondaryString();
            } else {
                return SMXreturn.getPrimaryString();
            }
        }
        return "how did you manage to reach this, AAAAAAAAAAAA end my suffering";
    }

    public String mostSimilar(String toBeCompared, String[] strings) {
        int minDistance = Integer.MAX_VALUE;
        String similar = "";
        for (String str : strings) {
            int d = LevenshteinDistance.computeLevenshteinDistance(str, toBeCompared);
            if (d < minDistance) {
                minDistance = d;
                similar = str;
            }
        }
        return similar;
    }

    public static List<String> cutContent(List<String> str) {
        List<String> returnlist = new ArrayList();
        for (String str1 : str) {
            int iend = str1.indexOf("content: ");
            if (iend != -1) {
                String trs = str1.substring(iend + 9);
                returnlist.add(trs.substring(0, trs.length() - 1));
            }
        }
        return returnlist;
    }

    public static List<String> filterContent(List<String> str) {
        List<String> strlistreturn = new ArrayList();
        for (String str1 : str) {
            if (str1.isEmpty() || str1.length() < 3) {
                continue;
            }
            str1 = str1.trim();
            if (str1.contains("PM*")) {
                str1 = str1.substring(str1.indexOf("PM*") + 5);
            }
            if (str1.contains("AM*")) {
                str1 = str1.substring(str1.indexOf("AM*") + 5);
            }
            for (Character c : str1.toCharArray()) {
                if (c == '?' || c == '°') {
                    str1 = str1.replace("?", " <:wlenny:514861023002624001> ");
                    str1 = str1.replace("°", " <:wlenny:514861023002624001> ");
                }
            }
            if (str1.contains("(Counter-Terrorist)")) {
                str1 = str1.replace("(Counter-Terrorist)", " ");
            }
            if (str1.contains("(Terrorist)")) {
                str1 = str1.replace("(Terrorist)", " ");
            }
            if (str1.contains("(Spectator)")) {
                str1 = str1.replace("(Spectator)", " ");
            }
            if (str1.contains("*DEAD*")) {
                str1 = str1.replace("*DEAD*", " ");
            }
            if (str1.contains("{red}")) {
                str1 = str1.replace("{red}", " ");
            }
            if (str1.contains("{orange}")) {
                str1 = str1.replace("{orange}", " ");
            }
            if (str1.contains("{yellow}")) {
                str1 = str1.replace("{yellow}", " ");
            }
            if (str1.contains("{green}")) {
                str1 = str1.replace("{green}", " ");
            }
            if (str1.contains("{lightblue}")) {
                str1 = str1.replace("{lightblue}", " ");
            }
            if (str1.contains("{blue}")) {
                str1 = str1.replace("{blue}", " ");
            }
            if (str1.contains("{purple}")) {
                str1 = str1.replace("{purple}", " ");
            }
            if (str1.contains("{white}")) {
                str1 = str1.replace("{white}", " ");
            }
            str1 = str1.trim();
            if (str1.length() > 2 && (!str1.startsWith("!"))) {
                strlistreturn.add(str1);
            }
        }
        return strlistreturn;
    }

    /*
    public static List<String> cutLongsFromEmotes(List<String> str) {
        List<String> strreturn = new ArrayList();
        int emotesTraceLong = 17;
        for (String str1 : str) {
            StringBuilder SB = new StringBuilder();
            int counter = 0;
            int i = 0;
            for (Character c : str1.toCharArray()) {
                i++;
                if (Character.isDigit(c)) {
                    counter++;
                    if (counter > emotesTraceLong && str1.length() > i + 2) {
                        SB.append(str1.substring(0, i - emotesTraceLong));
                        SB.append(str1.substring(i + 1, str1.length()));
                    }
                } else {
                    counter = 0;
                }
            }
            if (SB.toString().isEmpty()) {
                strreturn.add(str1);
            } else {
                strreturn.add(SB.toString());
            }
        }
        return strreturn;
    }
     */
    private List<String> removeSlacks(List<String> str) {
        ShiftReduceParser model = SentimentAnalyzerTest.getModel();
        MaxentTagger tagger = SentimentAnalyzerTest.getTagger();
        List<TaggedWord> taggedWords;
        List<String> strreturn = new ArrayList();
        for (String str1 : str) {
            int counter = 0;
            List<String> TGWList = new ArrayList();
            DocumentPreprocessor tokenizer = new DocumentPreprocessor(new StringReader(str1));
            for (List<HasWord> sentence : tokenizer) {
                List<TaggedWord> tagged1 = tagger.tagSentence(sentence);
                Tree tree = model.apply(tagged1);
                taggedWords = tree.taggedYield();
                for (TaggedWord TGW : taggedWords) {
                    if (!TGWList.contains(TGW.tag()) && !TGW.tag().equals(":") && !TGW.word().equals(TGW.tag())) {
                        TGWList.add(TGW.tag());
                        counter++;
                    }
                    if (counter > 3) {
                        int addCounter = 0;
                        List<Word> wordList = new ArrayList();
                        for (Word lab : tree.yieldWords()) {
                            if (lab != null && lab.word() != null) {
                                //System.out.println("lab: " + lab + " \n");
                                if (!wordList.contains(lab) && !lab.equals(":")) {
                                    wordList.add(lab);
                                    addCounter++;
                                }
                            }
                        }
                        if (addCounter > 3) {
                            addCounter = 0;
                            List<HasWord> HWlist = new ArrayList();
                            for (HasWord HW : tree.yieldHasWord()) {
                                if (HW != null && HW.word() != null && !HWlist.contains(HW)) {
                                    //System.out.println("HasWord: " + HW + "\n");
                                    addCounter++;
                                    HWlist.add(HW);
                                }
                            }
                            if (addCounter > 3) {
                                boolean tooclosematch = false;
                                for (String strVals : StringCache.values()) {
                                    double Distance = LevenshteinDistance.computeLevenshteinDistance(strVals, str1);
                                    int maxpermittedDistance = 5;
                                    if (Distance < maxpermittedDistance) {
                                        tooclosematch = true;
                                        break;
                                    }
                                }
                                if (!tooclosematch) {
                                    strreturn.add(str1);
                                }
                            }
                        }
                        break;
                    }
                }
                if (counter > 3) {
                    break;
                }
            }
        }
        return strreturn;
    }

    /**
     *
     * @throws CustomError
     * @deprecated
     */
    public synchronized void calculateStrings() throws CustomError {
        //linkedhashmap?
        int initiallimit = 5;
        int listindex = 0;
        List<SimilarityMatrix> WS4JList = DataMapper.getAllSementicMatrixes();
        List<SimilarityMatrix> WS4JListUpdate = new ArrayList();
        List<String> sentencesList = DataMapper.getAllStrings();
        for (int i = 1; i < initiallimit; i++) {
            if (!sentencesList.get(i).isEmpty()) {
                //System.out.print("i: " + i + "\n sentencesList i: " + sentencesList.get(i) + "\n");
                String[] words1 = sentencesList.get(i).split(" ");
                for (String words11 : words1) {
                    if (!words11.isEmpty() && words11.length() > 3) {
                        String str = words11;
                        if (!str.isEmpty() && str.length() > 3) {
                            //SecondaryPredicate, no secondary key present with word
                            Predicate<SimilarityMatrix> SecondaryPredicate = e -> str.equals(e.getSecondaryString());
                            //no primary key present with the word
                            if (!WS4JList.stream().filter(e -> str.equals(e.getPrimaryString())).findAny().isPresent()) {
                                WS4JListUpdate = createWS4JWordMatrix(str, sentencesList, WS4JListUpdate, WS4JList, SecondaryPredicate);
                                for (; listindex < WS4JListUpdate.size(); listindex++) {
                                    WS4JList.add(WS4JListUpdate.get(listindex));
                                }
                            }
                        }
                    }
                }
            }
        }
        //System.out.println("\nWS4JListUpdate size: " + WS4JListUpdate.size());
        DataMapper.insertSementicMatrixes(WS4JListUpdate);
    }

    /**
     *
     * @param str
     * @param strlist
     * @param ws4jlist
     * @param oldlist
     * @param SecondaryPredicate
     * @return
     * @deprecated
     */
    public List<SimilarityMatrix> createWS4JWordMatrix(String str, List<String> strlist, List<SimilarityMatrix> ws4jlist,
            List<SimilarityMatrix> oldlist, Predicate<SimilarityMatrix> SecondaryPredicate) {
        for (String str1 : strlist) {
            if (!str1.isEmpty()) {
                String[] words1 = str1.split(" ");
                for (int j = 0; j < words1.length; j++) {
                    if (!words1[j].isEmpty() && words1[j].length() > 3) {
                        String strword = words1[j];
                        if (!strword.isEmpty() && strword.length() > 3 && !strword.equals(str)) {
                            Predicate<SimilarityMatrix> PrimaryPredicate = e -> strword.equals(e.getPrimaryString());
                            if (!oldlist.stream().filter(PrimaryPredicate.and(SecondaryPredicate)).findAny().isPresent()) {
                                //System.out.println("creating SimilarityMatrix with STR: " + str + "\n strword: " + strword + "\n");
                                SimilarityMatrix ws4j = new SimilarityMatrix(str, strword);
                                /*
                                double addingDistance = ws4j.getDistanceCalculations();
                                if (addingDistance > 0.00) {
                                    //System.out.println("added! \n");
                                    ws4j.setDistance(addingDistance);
                                    ws4jlist.add(ws4j);
                                }
                                 */
                            }
                        }
                    }
                }
            }
        }
        return ws4jlist;
    }

    /**
     * Stanford Parser method to update calculations to the DB
     *
     * @deprecated
     * @throws FunctionLayer.CustomError
     */
    public void sentimentAnalyzingStringsToDB() throws CustomError {

        List<String> sentencesList = DataMapper.getAllStrings();
        List<SimilarityMatrix> WS4JList = DataMapper.getAllSementicMatrixes();
        List<SimilarityMatrix> WS4JListUpdate = new ArrayList();
        int listindex = 0;
        for (int i = 0; i < sentencesList.size() - 3000; i++) {
            String str = sentencesList.get(i);
            if (!str.isEmpty() && str.length() > 3) {
                //System.out.println("i: " + i + "\n");
                Predicate<SimilarityMatrix> SecondaryPredicate = e -> str.equals(e.getSecondaryString());
                if (!WS4JList.stream().filter(e -> str.equals(e.getPrimaryString())).findAny().isPresent()) {
                    //WS4JListUpdate = addStringMatrixes(str, sentencesList, SecondaryPredicate, WS4JListUpdate, WS4JList);
                    for (; listindex < WS4JListUpdate.size(); listindex++) {
                        WS4JList.add(WS4JListUpdate.get(listindex));
                    }
                }
            }
        }
        // System.out.println("\n WS4JListUpdate size: " + WS4JListUpdate.size());
        DataMapper.insertSementicMatrixes(WS4JListUpdate);
    }

    /**
     * @deprecated @param str Primary string which is checked, the filter
     * ensures primary string has not been calculated yet
     * @param sentencesList the full string list where each unique primary has
     * to calculate its value to the rest of the DB
     * @param SecondaryPredicate ensures primary string is not already
     * calculated somewhere with another string
     * @param WS4JListUpdate Matrix list to update in DB with new Sentences
     * @param OldWS4JList Check if str1 already has primary entry with
     * co-responding SecondaryPredicate
     * @return Updated List which has to be inserted to the DB
     */
    private List<SimilarityMatrix> addStringMatrixes(String str, List<String> sentencesList,
            Predicate<SimilarityMatrix> SecondaryPredicate, List<SimilarityMatrix> WS4JListUpdate,
            List<SimilarityMatrix> OldWS4JList, LexicalizedParser lp, TreebankLanguagePack tlp) {
        double valuerange = -100.0;
        for (int i = 0; i < sentencesList.size(); i++) {
            String str1 = sentencesList.get(i);
            if (!str1.isEmpty() && str1.length() > 3) {
                Predicate<SimilarityMatrix> PrimaryPredicate = e -> str1.equals(e.getPrimaryString());
                if (!OldWS4JList.stream().filter(PrimaryPredicate.and(SecondaryPredicate)).findAny().isPresent()) {
                    double s = -100.0;
                    if (s > valuerange) {
                        SimilarityMatrix SMX = new SimilarityMatrix(str, str1);
                        SMX.setDistance(s);
                        /*
                        System.out.println("SMX added: \n Primary: " + SMX.getPrimaryString() + "\n Secondary: " + SMX.getSecondaryString()
                                + "\n Score: " + SMX.getDistance() + "\n");
                         */
                        WS4JListUpdate.add(SMX);
                    }
                }
            }
        }
        /*
        str parameter is primary and not used as primary if reaching here
        secondary predicate ensures primary does not already exist as secondary with co-responding strlist primary
         */
        return WS4JListUpdate;
    }

}
